﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Type8PusherV3 : MonoBehaviour
{
    [SerializeField] bool forward = true;
    [SerializeField] float pusherLimitFront = 0.11f;
    [SerializeField] float pusherLimitBack = 0.25f;
    [SerializeField] float force = 10f;
    [SerializeField] float velocityThreshold = 0.05f;
    Rigidbody rb;

    void Start()
    {
        rb = GetComponent<Rigidbody>();
    }

    void Update()
    {
        if (!forward && transform.localPosition.z >= pusherLimitBack) forward = true;
        else if (forward && transform.localPosition.z <= pusherLimitFront) forward = false;
    }

    void FixedUpdate() // BUG:回転したときにPusherが動作しない不具合
    {
        if (forward && rb.velocity.z >= -velocityThreshold) rb.AddForce(new Vector3(0, 0, -force));
        if (!forward && rb.velocity.z <= velocityThreshold) rb.AddForce(new Vector3(0, 0, force));
    }
}
